D.10. text2pcap: Converting ASCII hexdumps to network captures
Prev | Appendix D. Related command line tools | Next

## D.10. text2pcap: Converting ASCII hexdumps to network captures

There may be some occasions when you wish to convert a hex dump of some network traffic into a capture file.

`text2pcap` is a program that reads in an ASCII hex dump and writes the data described into any capture file format supported by libwiretap. `text2pcap` can read hexdumps with multiple packets in them, and build a capture file of multiple packets. `text2pcap` is also capable of generating dummy Ethernet, IP, UDP, TCP or SCTP headers, in order to build fully processable packet dumps from hexdumps of application-level data only.

`text2pcap` understands a hexdump of the form generated by `od -A x -t x1`. In other words, each byte is individually displayed and surrounded with a space. Each line begins with an offset describing the position in the packet, each new packet starts with an offset of 0 and there is a space separating the offset from the following bytes. The offset is a hex number (can also be octal - see `-o`), of more than two hex digits. Here is a sample dump that `text2pcap` can recognize:

    000000 00 e0 1e a7 05 6f 00 10 ........
    000008 5a a0 b9 12 08 00 46 00 ........
    000010 03 68 00 00 00 00 0a 2e ........
    000018 ee 33 0f 19 08 7f 0f 19 ........
    000020 03 80 94 04 00 00 10 01 ........
    000028 16 a2 0a 00 03 50 00 0c ........
    000030 01 01 0f 19 03 80 11 01 ........

There is no limit on the width or number of bytes per line. Also the text dump at the end of the line is ignored. Bytes/hex numbers can be uppercase or lowercase. Any text before the offset is ignored, including email forwarding characters “>”. Any lines of text between the bytestring lines is ignored. The offsets are used to track the bytes, so offsets must be correct. Any line which has only bytes without a leading offset is ignored. An offset is recognized as being a hex number longer than two characters. Any text after the bytes is ignored (e.g., the character dump). Any hex numbers in this text are also ignored. An offset of zero is indicative of starting a new packet, so a single text file with a series of hexdumps can be converted into a packet capture with multiple packets. Packets may be preceded by a timestamp. These are interpreted according to the format given on the command line. If not, the first packet is timestamped with the current time the conversion takes place. Multiple packets are written with timestamps differing by one microsecond each. In general, short of these restrictions, `text2pcap` is pretty liberal about reading in hexdumps and has been tested with a variety of mangled outputs (including being forwarded through email multiple times, with limited line wrap etc.)

There are a couple of other special features to note. Any line where the first non-whitespace character is “#” will be ignored as a comment. Any line beginning with #TEXT2PCAP is a directive and options can be inserted after this command to be processed by `text2pcap`. Currently there are no directives implemented; in the future, these may be used to give more fine-grained control on the dump and the way it should be processed e.g., timestamps, encapsulation type etc.

`text2pcap` also allows the user to read in dumps of application-level data, by inserting dummy L2, L3 and L4 headers before each packet. Possibilities include inserting headers such as Ethernet, Ethernet + IP, Ethernet + IP + UDP, or TCP, or SCTP before each packet. This allows Wireshark or any other full-packet decoder to handle these dumps.

For more information on `text2pcap` consult your local manual page (`man text2pcap`) or the online version.

Help information available from text2pcap.

    Text2pcap (Wireshark) 4.6.6 (v4.6.6rc0-13-ge84b78a250e3)
    Generate a capture file from an ASCII hexdump of packets.
    See https://www.wireshark.org for more information.

    Usage: text2pcap [options] <infile> <outfile>

    where  <infile> specifies input  filename (use - for standard input)
          <outfile> specifies output filename (use - for standard output)

    Input:
      -o hex|oct|dec|none    parse offsets as (h)ex, (o)ctal, (d)ecimal, or (n)one;
                             default is hex.
      -t <timefmt>           treat the text before the packet as a date/time code;
                             <timefmt> is a format string supported by strptime,
                             with an optional %f descriptor for fractional seconds.
                             Example: The time "10:15:14.5476" has the format code
                             "%H:%M:%S.%f"
                             The special format string ISO supports ISO-8601 times.
                             NOTE: Date/time fields from the current date/time are
                             used as the default for unspecified fields.
      -D                     the text before the packet starts with an I or an O,
                             indicating that the packet is inbound or outbound.
                             This is used when generating dummy headers if the
                             output format supports it (e.g. pcapng).
      -a                     enable ASCII text dump identification.
                             The start of the ASCII text dump can be identified
                             and excluded from the packet data, even if it looks
                             like a HEX dump.
                             NOTE: Do not enable it if the input file does not
                             contain the ASCII text dump.
      -r <regex>             enable regex mode. Scan the input using <regex>, a Perl
                             compatible regular expression matching a single packet.
                             Named capturing subgroups are used to identify fields:
                             <data> (mand.), and <time>, <dir>, and <seqno> (opt.)
                             The time field format is taken from the -t option
                             Example: -r '^(?<dir>[<>])\s(?<time>\d+:\d\d:\d\d.\d+)\s(?<data>[0-9a-fA-F]+)$'
                             could match a file with lines like
                             > 0:00:00.265620 a130368b000000080060
                             < 0:00:00.295459 a2010800000000000000000800000000
      -b 2|8|16|64           encoding base (radix) of the packet data in regex mode
                             (def: 16: hexadecimal) No effect in hexdump mode.

    Output:
                             if the output file(s) have the .gz extension, then
                             gzip compression will be used.
      -F <capture type>      set the output file type; default is pcapng.
                             an empty "-F" option will list the file types.
      -E <encap type>        set the output file encapsulation type; default is
                             ether (Ethernet). An empty "-E" option will list
                             the encapsulation types.
      -l <typenum>           set the output file encapsulation type via link-layer
                             type number; default is 1 (Ethernet). See
                             https://www.tcpdump.org/linktypes.html for a list of
                             numbers.
                             Example: -l 7 for ARCNet packets.
      -m <max-packet>        max packet length in output; default is 262144
      -N <intf-name>         assign name to the interface in the pcapng file.
      --compress <type>      Compress the output file using the type compression format.

    Prepend dummy header:
      -e <ethertype>         prepend dummy Ethernet II header with specified EtherType
                             (in HEX).
                             Example: -e 0x806 to specify an ARP packet.
      -i <proto>             prepend dummy IP header with specified IP protocol
                             (in DECIMAL).
                             Automatically prepends Ethernet header as well if
                             link-layer type is Ethernet.
                             Example: -i 46
      -4 <srcip>,<destip>    prepend dummy IPv4 header with specified
                             source and destination addresses.
                             Example: -4 10.0.0.1,10.0.0.2
      -6 <srcip>,<destip>    prepend dummy IPv6 header with specified
                             source and destination addresses.
                             Example: -6 2001:db8::b3ff:fe1e:8329,2001:0db8:85a3::8a2e:0370:7334
      -u <srcp>,<destp>      prepend dummy UDP header with specified
                             source and destination ports (in DECIMAL).
                             Automatically prepends Ethernet & IP headers as well.
                             Example: -u 1000,69 to make the packets look like
                             TFTP/UDP packets.
      -T <srcp>,<destp>      prepend dummy TCP header with specified
                             source and destination ports (in DECIMAL).
                             Automatically prepends Ethernet & IP headers as well.
                             Example: -T 50,60
      -s <srcp>,<dstp>,<tag> prepend dummy SCTP header with specified
                             source/destination ports and verification tag (in DECIMAL).
                             Automatically prepends Ethernet & IP headers as well.
                             Example: -s 30,40,34
      -S <srcp>,<dstp>,<ppi> prepend dummy SCTP header with specified
                             source/destination ports and verification tag 0.
                             Automatically prepends a dummy SCTP DATA
                             chunk header with payload protocol identifier ppi.
                             Example: -S 30,40,34
      -P <dissector>         prepend EXPORTED_PDU header with specified dissector
                             as the payload DISSECTOR_NAME tag.
                             Automatically sets link type to Upper PDU Export.
                             EXPORTED_PDU payload defaults to "data" otherwise.

    Diagnostic output:
      --log-level <level>      sets the active log level ("critical", "warning", etc.)
      --log-fatal <level>      sets level to abort the program ("critical" or "warning")
      --log-domains <[!]list>  comma-separated list of the active log domains
      --log-fatal-domains <list>
                               list of domains that cause the program to abort
      --log-debug <[!]list>    list of domains with "debug" level
      --log-noisy <[!]list>    list of domains with "noisy" level
      --log-file <path>        file to output messages to (in addition to stderr)

    Miscellaneous:
      -h, --help             display this help and exit
      -v, --version          print version information and exit
      -q                     don't report processed packet counts

Prev | Up | Next
D.9. mergecap: Merging multiple capture files into one | Home | D.11. reordercap: Reorder a capture file